<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FlightRate ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FlightRate extends AbstractStructArrayBase
{
    /**
     * The FlightRate
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FlightRate[]
     */
    public $FlightRate;
    /**
     * Constructor method for ArrayOfJP_FlightRate
     * @uses ArrayOfJP_FlightRate::setFlightRate()
     * @param \StructType\JP_FlightRate[] $flightRate
     */
    public function __construct(array $flightRate = array())
    {
        $this
            ->setFlightRate($flightRate);
    }
    /**
     * Get FlightRate value
     * @return \StructType\JP_FlightRate[]|null
     */
    public function getFlightRate()
    {
        return $this->FlightRate;
    }
    /**
     * Set FlightRate value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightRate[] $flightRate
     * @return \ArrayType\ArrayOfJP_FlightRate
     */
    public function setFlightRate(array $flightRate = array())
    {
        foreach ($flightRate as $arrayOfJP_FlightRateFlightRateItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FlightRateFlightRateItem instanceof \StructType\JP_FlightRate) {
                throw new \InvalidArgumentException(sprintf('The FlightRate property can only contain items of \StructType\JP_FlightRate, "%s" given', is_object($arrayOfJP_FlightRateFlightRateItem) ? get_class($arrayOfJP_FlightRateFlightRateItem) : gettype($arrayOfJP_FlightRateFlightRateItem)), __LINE__);
            }
        }
        $this->FlightRate = $flightRate;
        return $this;
    }
    /**
     * Add item to FlightRate value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightRate $item
     * @return \ArrayType\ArrayOfJP_FlightRate
     */
    public function addToFlightRate(\StructType\JP_FlightRate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FlightRate) {
            throw new \InvalidArgumentException(sprintf('The FlightRate property can only contain items of \StructType\JP_FlightRate, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlightRate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FlightRate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FlightRate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FlightRate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FlightRate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FlightRate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightRate
     */
    public function getAttributeName()
    {
        return 'FlightRate';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_FlightRate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
